PCB Environment 2

Loading...
Searching...
No Matches
Public Member Functions
CircleEx Class Reference
Inheritance diagram for CircleEx:

## Public Member Functions
| CircleEx (const Circle_2 &base)
AShape * | clone () const override
CircleEx | grown (Real) const
uint | vertexCount () const override
bool | canDrawAsTriFan () const override
bool | isRound () const override
Real | unsignedArea () const override
Bbox_2 | bbox () const override
bool | transformPreservesType (const CGAL::Aff_transformation_2< Kernel > &) const override
void | transform (const CGAL::Aff_transformation_2< Kernel > &) override
void | translate (const ::Vector_2 &) override
bool | contains (const ::Point_2 &) const override
Real | squared_distance (const AShape &S) const override
Real | squared_distance (const ::Point_2 &) const override
Real | squared_distance (const Segment_2 &) const override
Real | squared_distance (const Circle_2 &) const override
Real | squared_distance (const Iso_rectangle_2 &) const override
Real | squared_distance (const Triangle_2 &) const override
Real | squared_distance (const Polygon_2 &) const override
Real | squared_distance (const WideSegment_25 &) const override
bool | intersects (const AShape &S) const override
bool | intersects (const Circle_2 &) const override
bool | intersects (const Iso_rectangle_2 &) const override
bool | intersects (const Triangle_2 &) const override
bool | intersects (const Polygon_2 &) const override
bool | intersects (const WideSegment_25 &) const override
::Point_2 | centroid () const override
std::string | str () const override
PyObject * | getPy () const override
Public Member Functions inherited from AShape
template<typename T>
T * | as ()
template<typename T>
const T * | as () const
virtual uint | indexCountWithRestart () const
Real | boundingRadius () const
virtual void | translate (const Vector_2 &)=0
virtual AShape * | transformType (const CGAL::Aff_transformation_2< Kernel > &)
virtual bool | contains (const Point_2 &) const =0
Real | squared_distance (const Bbox_2 &) const
bool | intersects (const Bbox_2 &) const

## Member Function Documentation

## ◆ bbox()

Bbox_2 CircleEx::bbox | ( |  | ) | const
| inline override virtual

Implements AShape.

## ◆ canDrawAsTriFan()

bool CircleEx::canDrawAsTriFan | ( |  | ) | const
| inline override virtual

Reimplemented from AShape.

## ◆ centroid()

::Point_2 CircleEx::centroid | ( |  | ) | const
| inline override virtual

Implements AShape.

## ◆ clone()

AShape * CircleEx::clone | ( |  | ) | const
| inline override virtual

Implements AShape.

## ◆ getPy()

PyObject * CircleEx::getPy | ( |  | ) | const
| override virtual

Return a Python representation of this object. Formats:

- ('circle', radius, x, y)
- ('triangle', v0, v1, v2) where v is (x,y,z)
- ('rect_iso', xmin, ymin, xmax, ymax)
- ('wide_segment', x0, y0, x1, y1, z, width)
- ('polygon', [v0, v1, v2, v3, ...]) where v is (x,y,z)

Implements AShape.

## ◆ intersects() [1/6]

bool CircleEx::intersects | ( | const AShape & | S | ) | const
| inline override virtual

Implements AShape.

## ◆ intersects() [2/6]

bool CircleEx::intersects | ( | const Circle_2 & |  | ) | const
| override virtual

Implements AShape.

## ◆ intersects() [3/6]

bool CircleEx::intersects | ( | const Iso_rectangle_2 & |  | ) | const
| override virtual

Implements AShape.

## ◆ intersects() [4/6]

bool CircleEx::intersects | ( | const Polygon_2 & |  | ) | const
| override virtual

Implements AShape.

## ◆ intersects() [5/6]

bool CircleEx::intersects | ( | const Triangle_2 & |  | ) | const
| override virtual

Implements AShape.

## ◆ intersects() [6/6]

bool CircleEx::intersects | ( | const WideSegment_25 & |  | ) | const
| override virtual

Implements AShape.

## ◆ isRound()

bool CircleEx::isRound | ( |  | ) | const
| inline override virtual

Reimplemented from AShape.

## ◆ squared_distance() [1/8]

Real CircleEx::squared_distance | ( | const ::Point_2 & |  | ) | const
| override virtual

Implements AShape.

## ◆ squared_distance() [2/8]

Real CircleEx::squared_distance | ( | const AShape & | S | ) | const
| inline override virtual

Implements AShape.

## ◆ squared_distance() [3/8]

Real CircleEx::squared_distance | ( | const Circle_2 & |  | ) | const
| override virtual

Implements AShape.

## ◆ squared_distance() [4/8]

Real CircleEx::squared_distance | ( | const Iso_rectangle_2 & |  | ) | const
| override virtual

Implements AShape.

## ◆ squared_distance() [5/8]

Real CircleEx::squared_distance | ( | const Polygon_2 & |  | ) | const
| override virtual

Implements AShape.

## ◆ squared_distance() [6/8]

Real CircleEx::squared_distance | ( | const Segment_2 & |  | ) | const
| override virtual

Implements AShape.

## ◆ squared_distance() [7/8]

Real CircleEx::squared_distance | ( | const Triangle_2 & |  | ) | const
| override virtual

Implements AShape.

## ◆ squared_distance() [8/8]

Real CircleEx::squared_distance | ( | const WideSegment_25 & |  | ) | const
| override virtual

Implements AShape.

## ◆ str()

std::string CircleEx::str | ( |  | ) | const
| override virtual

Implements AShape.

## ◆ transform()

void CircleEx::transform | ( | const CGAL::Aff_transformation_2< Kernel > & |  | ) |
| override virtual

Use transformType() if you are not sure whether the transformation preserves the shape type.

Implements AShape.

## ◆ transformPreservesType()

bool CircleEx::transformPreservesType | ( | const CGAL::Aff_transformation_2< Kernel > & |  | ) | const
| override virtual

Check whether the transformation would change the shape's underlying type (sorry).

- Iso_rectangle_2 may become a Polygon_2 when (angle % 90) != 0
- Circle_2 may become an ellipse when scaled (this is not supported)

Reimplemented from AShape.

## ◆ unsignedArea()

Real CircleEx::unsignedArea | ( |  | ) | const
| inline override virtual

Implements AShape.

## ◆ vertexCount()

uint CircleEx::vertexCount | ( |  | ) | const
| inline override virtual

assumes this is drawn as a quad

Implements AShape.

The documentation for this class was generated from the following file:

- /home/chr/devel/PhD/Environment/pub/PCBEnv/pcbenv/cxx/AShape.hpp